#include <SoftwareSerial.h>

SoftwareSerial mySerial = SoftwareSerial(9, 8); // RX, TX
//Scanner default 9600 baud , 8 data bits, no parity bit, 1 stop bit

void setup() 
{
  pinMode(9,INPUT);       //SoftwareSerial RX
  pinMode(8,OUTPUT);      //SoftwareSerial TX
  pinMode(7,OUTPUT);      //Scan Trigger
  digitalWrite(7, HIGH);  //Turn Scanner Off
  mySerial.begin(9600);   //Connect to Scanner Serial
  Serial.begin(9600);     //Connect to PC Serial Monitor
  while (!Serial);        //Wait for serial connection
  Serial.print("\n\n");
  Serial.println("Hit RETURN in serial monitor to start each scan...");
} 

void loop()
{ 
  if (Serial.available() > 0) 
  {
    //key press from Serial Monitor Detected
    Serial.read(); 
    digitalWrite(7, LOW);
    delay(3000);
    digitalWrite(7, HIGH);
    while (mySerial.available() > 0) 
    {
      // relay everything received from mySerial to Serial    
      Serial.write(mySerial.read()); 
    }
    Serial.print('\n');
  } 
} 



/* backup - this worked ok
void loop() { 
  digitalWrite(7, LOW);
  delay(7000);
  digitalWrite(7, HIGH);
  while (mySerial.available() > 0) {
    // relay everything received from mySerial to Serial    
    Serial.write(mySerial.read()); 
  }
  Serial.print('\n');
  delay(2000);
} 
*/




/* Pro Micro Test Code
   by: Nathan Seidle
   modified by: Jim Lindblom
   SparkFun Electronics
   date: September 16, 2013
   license: Public Domain - please use this code however you'd like.
   It's provided as a learning tool.

   This code is provided to show how to control the SparkFun
   ProMicro's TX and RX LEDs within a sketch. It also serves
   to explain the difference between Serial.print() and
   Serial1.print().
*/
/*
int RXLED = 17;  // The RX LED has a defined Arduino pin
// Note: The TX LED was not so lucky, we'll need to use pre-defined
// macros (TXLED1, TXLED0) to control that.
// (We could use the same macros for the RX LED too -- RXLED1,
//  and RXLED0.)

void setup()
{
  pinMode(RXLED, OUTPUT);  // Set RX LED as an output
  // TX LED is set as an output behind the scenes

  Serial.begin(9600); //This pipes to the serial monitor
  Serial.println("Initialize Serial Monitor");

  Serial1.begin(9600); //This is the UART, pipes to sensors attached to board
  Serial1.println("Initialize Serial Hardware UART Pins");
}

void loop()
{
  Serial.println("Hello world!");  // Print "Hello World" to the Serial Monitor
  Serial1.println("Hello! Can anybody hear me?");  // Print "Hello!" over hardware UART

  digitalWrite(RXLED, LOW);   // set the RX LED ON
  TXLED0; //TX LED is not tied to a normally controlled pin so a macro is needed, turn LED OFF
  delay(1000);              // wait for a second

  digitalWrite(RXLED, HIGH);    // set the RX LED OFF
  TXLED1; //TX LED macro to turn LED ON
  delay(1000);              // wait for a second
}
*/
